#include <fstream>
#include <vector>
#include <queue>
#include <fstream>
#include <tuple>
using namespace std;

ifstream fin("dijkstra.in");
ofstream fout("dijkstra.out");

const int Inf = 0x3f3f3f3f;

struct Pair {
	int node, dist;
	bool operator < (const Pair& p) const
	{
		return dist > p.dist;
	}
};

using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;
using VI  = vector<int>;

int n;
VI d;  // d[x] = dist minima de la sursa la nodul x
VVP G;

void CitesteGraf();
void Dijkstra(int x, VI& d);
void AfiseazaDistante(const VI& d);


int main()
{
	CitesteGraf();
	Dijkstra(1, d);
	AfiseazaDistante(d);
}

void Dijkstra(int x, VI& d)
{
	d = VI(n + 1, Inf);
	priority_queue<Pair> Q; // min-HEAP 
	
	d[x] = 0;
	Q.push({x, 0});
	
	int y, w, dist;
	while (!Q.empty())
	{
		x = Q.top().node;
		dist = Q.top().dist;
		Q.pop();
		if (dist > d[x])
			continue;
			
		for (auto& p : G[x])
		{
			y = p.first;
			w = p.second;
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				Q.push({y, d[y]});
			}
		}		
	}
}

void AfiseazaDistante(const VI& d)
{
	for (int i = 1; i <= n; ++i)
		fout << d[i] << ' ';
}

void CitesteGraf()
{
	int x, y, w; 
	fin >> n;
	
	G = VVP(n + 1);
	
	while (fin >> x >> y >> w)
	{
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}
}

